# QuAM API Reference

Welcome to the API Reference section of the Quantum Abstract Machine (QuAM) documentation. Here, you'll find comprehensive details on all components, classes, and methods that make up the QuAM framework. This documentation is designed to help developers understand and effectively utilize the powerful capabilities of QuAM for quantum computing applications.

## Quick Links

- [**Core Components**](/API_references/core/quam_classes_API)  
  Details on fundamental building blocks like [QuamBase][quam.core.quam_classes.QuamBase], [QuamComponent][quam.core.quam_classes.QuamComponent] and [QuamRoot][quam.core.quam_classes.QuamRoot].
  [QuamBase][quam.core.quam_classes.QuamBase]

- [**Channel Components**](/API_references/components/channels_API)  
  Learn about channel configurations and their operations within the QuAM framework.

- [**Pulse Components**](/API_references/components/pulses_API)  
  A detailed look at various pulse types and their properties used in quantum operations.
  
- [**Hardware Components**](/API_references/components/hardware_API)  
  Explore the hardware-related classes such as [Mixer][quam.components.hardware.Mixer], [LocalOscillator][quam.components.hardware.LocalOscillator], and [FrequencyConverter][quam.components.hardware.FrequencyConverter].

- [**Octave Components**](/API_references/components/octave_API)  
  Documentation on the `Octave` component and its associated up and down converters.

- [**BasicQuAM Class**](/API_references/components/basic_quam_API)  
  Details on the `BasicQuAM` class, the root-level QuAM instance that serves as the entry point for QuAM configurations.