# """Generate the code reference pages."""

from pathlib import Path

import mkdocs_gen_files

for path in sorted(Path("quam").rglob("*.py")):  #
    module_path = path.relative_to("quam").with_suffix("")  #
    doc_path = path.relative_to("quam").with_suffix(".md")  #
    full_doc_path = Path("API_references", doc_path)  #

    parts = list(module_path.parts)
    parts = ["quam"] + parts

    if parts[-1] == "__init__":  #
        parts = parts[:-1]
        continue
    elif parts[-1] == "__main__":
        continue

    with mkdocs_gen_files.open(full_doc_path, "w") as fd:  #
        identifier = ".".join(parts)  #
        print("::: " + identifier, file=fd)  #

    mkdocs_gen_files.set_edit_path(full_doc_path, path)  #
